<?php
namespace Geral\Entities;

/**
 * @method \Geral\Entities\Enderecoparc findByNrparcnegocioAndNrorg($nrparcnegocio, $nrorg)      static
 * @method \Geral\Entities\Enderecoparc findOneByNrparcnegocioAndCdtipoenderecoAndNrorg($nrparcnegocio, $Cdtipoendereco,  $nrorg) static
 * @method \Geral\Entities\Enderecoparc findOneByNrenderecoparcAndNrorg($Nrenderecoparc, $nrorg) static*
 * @method \Geral\Entities\Enderecoparc findOneByCdtipoinscricaoAndNrinscricaoparcAndNrorg($cdtipoinscricao, $nrinscricaoparc, $nrorg) static
 */

class Enderecoparc extends Base\Enderecoparc
{
    public function __contruct(){
        $this->idativo = 'S';
        $this->dtinclusao = new \DateTime();
    }

    // LISTA DE MÉTODOS UTILIZADOS EXCLUISIVAMENTE NA MIGRACAO ALINUTRI.
    public static function geraNovoCodigoMigracaoEstrutura($parcnegocio, $nrorg)
    {
        $nrenderecoparc = \Geral\Repositories\Enderecoparc::getEnderecoPrincipalParceiro($parcnegocio, $nrorg);
        if (!$nrenderecoparc) {
                $nrenderecoparc = \Geral\Util\NovoCodigo::geraNovoCodigoMigracao('ENDERECOPARC', 'NRENDERECOPARC', $nrorg);
    }
        
        return $nrenderecoparc;
    }

    /**
     * return object Municipio from EnderecoParc
     * @return Municipio
     */
    public function getMunicipio()
    {
        if(empty($this->municipio)){
            $where = "CDMUNICIPIO = :P_CDMUNICIPIO AND CDPAIS = :P_CDPAIS AND SGESTADO = :P_SGESTADO AND (NRORG = :P_NRORG OR NRORG = :P_NRORG_PADRAO)";
            $params = array(
                "P_CDPAIS" => $this->cdpais,
                "P_SGESTADO" => $this->sgestado,
                "P_CDMUNICIPIO" => $this->cdmunicipio,
                "P_NRORG" => $this->nrorg,
                "P_NRORG_PADRAO" => \FPA::getNrorgPadrao()
            );
            $this->municipio = Municipio::getObjectByWhere($where, $params);
        }
            return $this->municipio;
    }
}