/* Tabela COLLAYOUTIMP: TABELA DE COLUNAS DO LAYOUT DE IMPORTAO*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela COLLAYOUTIMP */
/* Objetivo: Gerar um log que vai registrar as alteraes na TABLAYOUTIMP,
             utilizando a tabela de Logs de Operaes do VND*/
CREATE OR REPLACE TRIGGER LOG_VND_COLLAYOUTIMP
AFTER DELETE OR INSERT OR UPDATE
ON COLLAYOUTIMP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
		IF NVL(:NEW.CDLAYOUTIMP,'ISNULL') <> NVL(:OLD.CDLAYOUTIMP,'ISNULL') THEN
			V_DESC   := 'Cd Layout Imp ' || '' || NVL(:NEW.CDLAYOUTIMP,'' );
		END IF;
		IF NVL(:NEW.NRSEQTABELAY,'ISNULL') <> NVL(:OLD.NRSEQTABELAY,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Nr Seq da Tabela ' || '' || NVL(:NEW.NRSEQTABELAY,'');
		END IF;
		IF NVL(:NEW.IDFUNARQLAY,'ISNULL') <> NVL(:OLD.IDFUNARQLAY,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Id Funo Oper ' || '' || NVL(:NEW.IDFUNARQLAY,'' );
		END IF;
		IF NVL(:NEW.NRSEQCOLULAY,'ISNULL') <> NVL(:OLD.NRSEQCOLULAY,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'NRSEQCOLULAY ' || '' || NVL(:NEW.NRSEQCOLULAY,'');
		END IF;
		IF NVL(:NEW.NRPOSICOLLAY,999999) <> NVL(:OLD.NRPOSICOLLAY,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'NRPOSICOLLAY ' || '' || NVL(:NEW.NRPOSICOLLAY,'');
		END IF;
		IF NVL(:NEW.NRTAMCOLLAY,999999) <> NVL(:OLD.NRTAMCOLLAY,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'NRTAMCOLLAY ' || '' || NVL(:NEW.NRTAMCOLLAY,'' );
		END IF;
		IF NVL(:NEW.NRCASASDECIM,999999) <> NVL(:OLD.NRCASASDECIM,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'NRCASASDECIM ' || '' || NVL(:NEW.NRCASASDECIM,'');
		END IF;
		IF NVL(:NEW.DSDEFACOLLAY,'ISNULL') <> NVL(:OLD.DSDEFACOLLAY,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'DSDEFACOLLAY ' || '' || NVL(:NEW.DSDEFACOLLAY,'');
		END IF;
		IF NVL(:NEW.DSDEFACOLLAY,'ISNULL') <> NVL(:OLD.DSDEFACOLLAY,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'IDGERSEQCOLU ' || '' || NVL(:NEW.IDGERSEQCOLU,'');
		END IF;
		IF NVL(:NEW.IDTDADCOLLAY,'ISNULL') <> NVL(:OLD.IDTDADCOLLAY,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'IDTDADCOLLAY ' || '' || NVL(:NEW.IDTDADCOLLAY,'');
		END IF;
		IF NVL(:NEW.IDGERCODCOLU,'ISNULL') <> NVL(:OLD.IDGERCODCOLU,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'IDGERCODCOLU ' || '' || NVL(:NEW.IDGERCODCOLU,'');
		END IF;
		IF NVL(:NEW.CDFRMTCOLLAY,'ISNULL') <> NVL(:OLD.CDFRMTCOLLAY,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'CDFRMTCOLLAY ' || '' || NVL(:NEW.CDFRMTCOLLAY,'');
		END IF;
		IF NVL(:NEW.NMTABELAIMP,'ISNULL') <> NVL(:OLD.NMTABELAIMP,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'NMTABELAIMP ' || '' || NVL(:NEW.NMTABELAIMP,'' );
		END IF;
		IF NVL(:NEW.NMCOLUNAIMP,'ISNULL') <> NVL(:OLD.NMCOLUNAIMP,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'NMCOLUNAIMP ' || '' || NVL(:NEW.NMCOLUNAIMP,'' );
		END IF;
		IF NVL(:NEW.NMCOLUNAAUX,'ISNULL') <> NVL(:OLD.NMCOLUNAAUX,'ISNULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'NMCOLUNAAUX ' || '' || NVL(:NEW.NMCOLUNAAUX,'' );
		END IF;
	  V_ITPESQ := :NEW.CDLAYOUTIMP||:NEW.NRSEQTABELAY||:NEW.IDFUNARQLAY||:NEW.NRSEQCOLULAY;
          V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Cd Layout Imp '     || '' || NVL(:NEW.CDLAYOUTIMP,'' )   || ' ' ||
                  'Nr Seq da Tabela '  || '' || NVL(:NEW.NRSEQTABELAY,'')   || ' ' ||
                  'Id Funo Oper '    || '' || NVL(:NEW.IDFUNARQLAY,'' )   || ' ' ||
                  'NRSEQCOLULAY '      || '' || NVL(:NEW.NRSEQCOLULAY,'')   || ' ' ||
                  'NRPOSICOLLAY '      || '' || NVL(:NEW.NRPOSICOLLAY,'')   || ' ' ||
                  'NRTAMCOLLAY '       || '' || NVL(:NEW.NRTAMCOLLAY,'' )   || ' ' ||
                  'NRCASASDECIM '      || '' || NVL(:NEW.NRCASASDECIM,'')   || ' ' ||
                  'DSDEFACOLLAY '      || '' || NVL(:NEW.DSDEFACOLLAY,'')   || ' ' ||
                  'IDGERSEQCOLU '      || '' || NVL(:NEW.IDGERSEQCOLU,'')   || ' ' ||
                  'IDTDADCOLLAY '      || '' || NVL(:NEW.IDTDADCOLLAY,'')   || ' ' ||
                  'IDGERCODCOLU '      || '' || NVL(:NEW.IDGERCODCOLU,'')   || ' ' ||
                  'CDFRMTCOLLAY '      || '' || NVL(:NEW.CDFRMTCOLLAY,'')   || ' ' ||
                  'NMTABELAIMP '       || '' || NVL(:NEW.NMTABELAIMP,'' )   || ' ' ||
                  'NMCOLUNAIMP '       || '' || NVL(:NEW.NMCOLUNAIMP,'' )   || ' ' ||
                  'NMCOLUNAAUX '       || '' || NVL(:NEW.NMCOLUNAAUX,'' );
      V_ITPESQ := :NEW.CDLAYOUTIMP||:NEW.NRSEQTABELAY||:NEW.IDFUNARQLAY||:NEW.NRSEQCOLULAY;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Cd Layout Imp '     || '' || NVL(:OLD.CDLAYOUTIMP,'' )   || ' ' ||
                  'Nr Seq da Tabela '  || '' || NVL(:OLD.NRSEQTABELAY,'')   || ' ' ||
                  'Id Funo Oper '    || '' || NVL(:OLD.IDFUNARQLAY,'' )   || ' ' ||
                  'NRSEQCOLULAY '      || '' || NVL(:OLD.NRSEQCOLULAY,'')   || ' ' ||
                  'NRPOSICOLLAY '      || '' || NVL(:OLD.NRPOSICOLLAY,'')   || ' ' ||
                  'NRTAMCOLLAY '       || '' || NVL(:OLD.NRTAMCOLLAY,'' )   || ' ' ||
                  'NRCASASDECIM '      || '' || NVL(:OLD.NRCASASDECIM,'')   || ' ' ||
                  'DSDEFACOLLAY '      || '' || NVL(:OLD.DSDEFACOLLAY,'')   || ' ' ||
                  'IDGERSEQCOLU '      || '' || NVL(:OLD.IDGERSEQCOLU,'')   || ' ' ||
                  'IDTDADCOLLAY '      || '' || NVL(:OLD.IDTDADCOLLAY,'')   || ' ' ||
                  'IDGERCODCOLU '      || '' || NVL(:OLD.IDGERCODCOLU,'')   || ' ' ||
                  'CDFRMTCOLLAY '      || '' || NVL(:OLD.CDFRMTCOLLAY,'')   || ' ' ||
                  'NMTABELAIMP '       || '' || NVL(:OLD.NMTABELAIMP,'' )   || ' ' ||
                  'NMCOLUNAIMP '       || '' || NVL(:OLD.NMCOLUNAIMP,'' )   || ' ' ||
                  'NMCOLUNAAUX '       || '' || NVL(:OLD.NMCOLUNAAUX,'' );
      V_ITPESQ := :OLD.CDLAYOUTIMP||:OLD.NRSEQTABELAY||:OLD.IDFUNARQLAY||:OLD.NRSEQCOLULAY;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND)
   VALUES
      ('COLLAYOUTIMP',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_COLLAYOUTIMP','5.20.001'); END;
/
